using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace RowsAndDataViewFind 
{
	public class FindDemo : System.Windows.Forms.Form 
	{
		private SqlConnection cn;
		private SqlCommand cmd; 
		private SqlDataAdapter da; 
		private DataSet ds;  

		internal System.Windows.Forms.TextBox txtFoundRow;
		internal System.Windows.Forms.TextBox txtFindArg;
		internal System.Windows.Forms.Button btnFind;
		internal System.Windows.Forms.Button btnFindRow;
		internal System.Windows.Forms.DataGrid DataGrid;
		private System.Windows.Forms.Label lbl_enter;
		private System.Windows.Forms.Label lbl_showrow;
		private System.ComponentModel.Container components = null;

		public FindDemo() 
		{
			try 
			{
				InitializeComponent();

				// Connect to Database and create Controls
				cn = new SqlConnection("server=xeon;database=northwind;uid=sa;pwd=manager");
				cmd = new SqlCommand("Select * from customers",cn);
				cmd.CommandType = CommandType.Text;
				da = new SqlDataAdapter(cmd);
				ds = new DataSet();
				RunQuery();
			}
			catch(Exception ex) 
			{
				MessageBox.Show(ex.ToString());
			}
		}

		// Fll DataGrid with Data
		private void RunQuery() 
		{
			try 
			{
				DataColumn[] dcPk = new DataColumn[1];

				da.Fill(ds, "Customers");

				// Set Primary Key
				dcPk[0] = ds.Tables["Customers"].Columns["CustomerID"];
				ds.Tables["Customers"].PrimaryKey = dcPk;

				// Set Default Sort
				ds.Tables[0].DefaultView.Sort = "CustomerID";
				DataGrid.DataSource = ds.Tables[0];
			}
			catch (Exception ex) 
			{
				MessageBox.Show(ex.ToString());
				Debug.WriteLine(ex.ToString());
			}
		}

		protected override void Dispose( bool disposing ) 
		{
			if( disposing ) 
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() 
		{
			this.txtFoundRow = new System.Windows.Forms.TextBox();
			this.txtFindArg = new System.Windows.Forms.TextBox();
			this.btnFind = new System.Windows.Forms.Button();
			this.DataGrid = new System.Windows.Forms.DataGrid();
			this.btnFindRow = new System.Windows.Forms.Button();
			this.lbl_enter = new System.Windows.Forms.Label();
			this.lbl_showrow = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.DataGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// txtFoundRow
			// 
			this.txtFoundRow.Location = new System.Drawing.Point(19, 80);
			this.txtFoundRow.Name = "txtFoundRow";
			this.txtFoundRow.Size = new System.Drawing.Size(491, 20);
			this.txtFoundRow.TabIndex = 16;
			this.txtFoundRow.Text = "";
			// 
			// txtFindArg
			// 
			this.txtFindArg.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtFindArg.Location = new System.Drawing.Point(111, 16);
			this.txtFindArg.Name = "txtFindArg";
			this.txtFindArg.Size = new System.Drawing.Size(200, 20);
			this.txtFindArg.TabIndex = 14;
			this.txtFindArg.Text = "CACTU";
			// 
			// btnFind
			// 
			this.btnFind.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnFind.Location = new System.Drawing.Point(319, 14);
			this.btnFind.Name = "btnFind";
			this.btnFind.Size = new System.Drawing.Size(104, 24);
			this.btnFind.TabIndex = 13;
			this.btnFind.Text = "Find the Row";
			this.btnFind.Click += new System.EventHandler(this.btnFind_Click);
			// 
			// DataGrid
			// 
			this.DataGrid.AlternatingBackColor = System.Drawing.Color.LightGray;
			this.DataGrid.BackColor = System.Drawing.Color.DarkGray;
			this.DataGrid.CaptionBackColor = System.Drawing.Color.White;
			this.DataGrid.CaptionFont = new System.Drawing.Font("Verdana", 10F);
			this.DataGrid.CaptionForeColor = System.Drawing.Color.Navy;
			this.DataGrid.CaptionText = "Customers";
			this.DataGrid.DataMember = "";
			this.DataGrid.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.DataGrid.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.DataGrid.ForeColor = System.Drawing.Color.Black;
			this.DataGrid.GridLineColor = System.Drawing.Color.Black;
			this.DataGrid.GridLineStyle = System.Windows.Forms.DataGridLineStyle.None;
			this.DataGrid.HeaderForeColor = System.Drawing.Color.Black;
			this.DataGrid.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.DataGrid.LinkColor = System.Drawing.Color.Navy;
			this.DataGrid.Location = new System.Drawing.Point(0, 117);
			this.DataGrid.Name = "DataGrid";
			this.DataGrid.ParentRowsBackColor = System.Drawing.Color.White;
			this.DataGrid.ParentRowsForeColor = System.Drawing.Color.Black;
			this.DataGrid.ReadOnly = true;
			this.DataGrid.SelectionBackColor = System.Drawing.Color.Navy;
			this.DataGrid.SelectionForeColor = System.Drawing.Color.White;
			this.DataGrid.Size = new System.Drawing.Size(536, 368);
			this.DataGrid.TabIndex = 10;
			// 
			// btnFindRow
			// 
			this.btnFindRow.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnFindRow.Location = new System.Drawing.Point(424, 14);
			this.btnFindRow.Name = "btnFindRow";
			this.btnFindRow.Size = new System.Drawing.Size(104, 24);
			this.btnFindRow.TabIndex = 12;
			this.btnFindRow.Text = "Show the Row";
			this.btnFindRow.Click += new System.EventHandler(this.btnFindRow_Click);
			// 
			// lbl_enter
			// 
			this.lbl_enter.Location = new System.Drawing.Point(16, 20);
			this.lbl_enter.Name = "lbl_enter";
			this.lbl_enter.Size = new System.Drawing.Size(100, 16);
			this.lbl_enter.TabIndex = 17;
			this.lbl_enter.Text = "Enter CustomerID";
			// 
			// lbl_showrow
			// 
			this.lbl_showrow.Location = new System.Drawing.Point(16, 63);
			this.lbl_showrow.Name = "lbl_showrow";
			this.lbl_showrow.Size = new System.Drawing.Size(100, 11);
			this.lbl_showrow.TabIndex = 18;
			this.lbl_showrow.Text = "Show found Row";
			// 
			// FindDemo
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 485);
			this.Controls.Add(this.lbl_showrow);
			this.Controls.Add(this.txtFoundRow);
			this.Controls.Add(this.txtFindArg);
			this.Controls.Add(this.btnFind);
			this.Controls.Add(this.DataGrid);
			this.Controls.Add(this.btnFindRow);
			this.Controls.Add(this.lbl_enter);
			this.Name = "FindDemo";
			this.Text = "Filtering and Sorting with Find (Rows, DataView)";
			((System.ComponentModel.ISupportInitialize)(this.DataGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new FindDemo());
		}

		// Finds a row in the DataView by the specified sort key value
		private void btnFind_Click(object sender, System.EventArgs e) 
		{
			try 
			{
				int intRow;

				// Finds the row specified in txtFindArg
				intRow = ds.Tables[0].DefaultView.Find(txtFindArg.Text);
				Debug.WriteLine(intRow);
				if (intRow == -1) 
				{
					MessageBox.Show("No PK matches " + txtFindArg.Text);
				}
				else 
				{
					// Jump to the Row and select it
					DataGrid.CurrentRowIndex = intRow;
					DataGrid.Select(intRow);
				}
			}
			catch(Exception ex) 
			{
				MessageBox.Show(ex.ToString());
			}
		}

		// Most applications that consume data need to access specific
		// records that satisfy some kind of criteria. In order to find
		// a particular row in a dataset you invoke the Find Method of
		// the DataRowCollection. If the primary key exists, a DataRow
		// object is returned. If the primary key cannot be found, a null
		// value is returned.
		private void btnFindRow_Click(object sender, System.EventArgs e) 
		{
			try 
			{
				DataRow drFound;

				// Find the Row specified in txtFindArg
				drFound = ds.Tables[0].Rows.Find(txtFindArg.Text);
				if (drFound == null) 
				{
					MessageBox.Show("No PK matches " + txtFindArg.Text);
				}
				else 
				{
					txtFoundRow.Text = drFound[0].ToString() + ", " +
						               drFound[1].ToString() + ", " +
                                       drFound[2].ToString();
				}
			}
			catch(Exception ex) 
			{
				MessageBox.Show(ex.ToString());
				Debug.WriteLine(ex.ToString());
			}
		}
	}
}