using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace RowsContain {

    public class ContainAndRemove : System.Windows.Forms.Form {
        private SqlConnection cn;
        private SqlCommand cmd;
        private SqlDataAdapter da;
        private DataSet ds; 
        private DataRow rowFound;
        internal System.Windows.Forms.Button btnSearch;
        internal System.Windows.Forms.TextBox txtSearchFor;
        internal System.Windows.Forms.Button btnRemoveRow;
        internal System.Windows.Forms.DataGrid DataGrid;
		internal System.Windows.Forms.Label lblSearch;
        private System.ComponentModel.Container components = null;

        public ContainAndRemove() {
            try{
                InitializeComponent();

				// Connect to the Database
                cn = new SqlConnection("server=xeon;database=northwind;uid=sa;pwd=manager");
                cmd = new SqlCommand("SELECT * FROM Customers ORDER BY CustomerID", cn);
                da= new SqlDataAdapter(cmd);
                ds= new DataSet();

                da.Fill(ds);
                DataGrid.PreferredColumnWidth = 200;
                DataGrid.DataSource = ds.Tables[0];

            }
            catch(Exception ex) {
                Debug.WriteLine(ex.ToString());
                MessageBox.Show(ex.ToString());
            }
        }

        protected override void Dispose( bool disposing ) {
            if( disposing ) {
                if (components != null) {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

#region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
			this.lblSearch = new System.Windows.Forms.Label();
			this.btnSearch = new System.Windows.Forms.Button();
			this.txtSearchFor = new System.Windows.Forms.TextBox();
			this.btnRemoveRow = new System.Windows.Forms.Button();
			this.DataGrid = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.DataGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// lblSearch
			// 
			this.lblSearch.Location = new System.Drawing.Point(118, 354);
			this.lblSearch.Name = "lblSearch";
			this.lblSearch.Size = new System.Drawing.Size(120, 16);
			this.lblSearch.TabIndex = 9;
			this.lblSearch.Text = "Customer ID";
			// 
			// btnSearch
			// 
			this.btnSearch.Location = new System.Drawing.Point(16, 371);
			this.btnSearch.Name = "btnSearch";
			this.btnSearch.Size = new System.Drawing.Size(96, 24);
			this.btnSearch.TabIndex = 8;
			this.btnSearch.Text = "Search for ...";
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			// 
			// txtSearchFor
			// 
			this.txtSearchFor.Location = new System.Drawing.Point(120, 372);
			this.txtSearchFor.Name = "txtSearchFor";
			this.txtSearchFor.Size = new System.Drawing.Size(160, 20);
			this.txtSearchFor.TabIndex = 7;
			this.txtSearchFor.Text = "";
			// 
			// btnRemoveRow
			// 
			this.btnRemoveRow.Location = new System.Drawing.Point(494, 371);
			this.btnRemoveRow.Name = "btnRemoveRow";
			this.btnRemoveRow.Size = new System.Drawing.Size(112, 24);
			this.btnRemoveRow.TabIndex = 6;
			this.btnRemoveRow.Text = "Remove This Row";
			this.btnRemoveRow.Click += new System.EventHandler(this.btnRemoveRow_Click);
			// 
			// DataGrid
			// 
			this.DataGrid.DataMember = "";
			this.DataGrid.Dock = System.Windows.Forms.DockStyle.Top;
			this.DataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.DataGrid.Location = new System.Drawing.Point(0, 0);
			this.DataGrid.Name = "DataGrid";
			this.DataGrid.Size = new System.Drawing.Size(624, 344);
			this.DataGrid.TabIndex = 5;
			// 
			// ContainAndRemove
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 413);
			this.Controls.Add(this.btnSearch);
			this.Controls.Add(this.txtSearchFor);
			this.Controls.Add(this.btnRemoveRow);
			this.Controls.Add(this.DataGrid);
			this.Controls.Add(this.lblSearch);
			this.Name = "ContainAndRemove";
			this.Text = "Rows Collection Contains and Remove Method";
			((System.ComponentModel.ISupportInitialize)(this.DataGrid)).EndInit();
			this.ResumeLayout(false);

		}
#endregion


        [STAThread]
        static void Main() {
            Application.Run(new ContainAndRemove());
        }

		// Gets a value indicating whether the primary key column(s)
		// of any row in the collection contains the specified value.
        private void btnSearch_Click(object sender, System.EventArgs e) 
		{
            try {
                DataTable tb = ds.Tables[0];
                int intRow;

				// Set Primary Key and Sort Order
                DataColumn[] dcolPk = new DataColumn[1];
                dcolPk[0] = tb.Columns["CustomerID"];
                tb.PrimaryKey = dcolPk;
                tb.DefaultView.Sort = "CustomerID";

				// Rows.Contains returns TRUE or FALSE
                if (tb.Rows.Contains(txtSearchFor.Text)) {

                    // At least one row matches primary key
                    rowFound = tb.Rows.Find(txtSearchFor.Text);
                    intRow = ds.Tables[0].DefaultView.Find(txtSearchFor.Text);
                    if ((rowFound == null) | (intRow == -1)) {
                        MessageBox.Show("Could not find row ");
                    }
                    else {
                        DataGrid.CurrentRowIndex = intRow;
						DataGrid.Select(intRow);
                    }
                }
                else {
                    MessageBox.Show("No row found that matches " + txtSearchFor.Text);
                }
            }
            catch(Exception ex) {
                Debug.WriteLine(ex.ToString());
                MessageBox.Show(ex.ToString());
            }
        }

		// When a row is removed, all data in that row is lost. You can
		// also call the Delete method of the DataRow class to simply mark
		// a row for removal. Calling Remove is the same as calling Delete
		// and then calling AcceptChanges.
		// You can also use the Clear method to remove all members of
		// the collection at once.
        private void btnRemoveRow_Click(object sender, System.EventArgs e) 
		{
            try {
                ds.Tables[0].Rows.Remove(rowFound);
            }
            catch(Exception ex) {
                Debug.WriteLine(ex.ToString());
                MessageBox.Show(ex.ToString());
            }
        }
    }
}